=begin rdoc
=end
gem 'more_unit_test', '> 0.0.2'
require 'more_unit_test/assert_equal_filecontent'

=begin rdoc
Generic test definition for testcases.
=end
module Rake4latex_testhelper
=begin rdoc
Test testcase(s).

Example:
  class Test_testdocument < Test::Unit::TestCase
    include Rake4latex_testhelper
    #run testcase in directory 'splitindex'
    def test_splitindex
      mytest_testcase( 'splitindex')
    end
  end

1) Changes to test directory and look for a rakefile.rb.
2) Scan rakefile.rb for basefile
3) Scan rakefile.rb for task :test____ and call rake for it
4) Compare output with expected result

=end
  def define_testcase( dir )
    assert_equal( true, File.directory?(dir))

    Dir.chdir(dir){
      assert_equal( true, File.exist?('rakefile.rb'), "No rakefile in #{dir}")
      #clean and check if test directory is empty in advance.
      `call rake clobber`
      assert_equal( true, Dir['*.{aux,log}'].empty?, "<#{dir}> contains old testdata")
      
      #Logger umhngen auf file
      #~ LaTeXRunner.logger.outputters = Log4r::FileOutputter.new("#{dir}.log4r")
      LaTeXRunner::DEFAULT_SETTINGS[:loglevel] = Log4r::INFO
      #testcases: test (test1 test2 ...)
      testcase = nil
      File.open('rakefile.rb'){|rakefile|
        rakefile_content = rakefile.read
        assert_match(/^\s*task\s*:basefile\s*=>|Rake4LaTeX::Basefile.set/, rakefile_content, "Missing basefile-task in Test #{dir}")
        #Get all test cases
        rakefile_content.scan(/^task\s*:(test\S*)\s*=>(.*)$/){|hit|
          testcase = hit.first
          dircontent = Dir['*'] #Remember the directory content before the task
          result = `call rake #{testcase}`
          result.sub!(/\(in .*?$/,'')  #delete first line from rake (depends on directory the test runs).
          result.sub!(/^call (.*?)\n$/,'')  if RUBY_VERSION =~ /1.9/

          #Take a look on the prerequisites
          case hit[1]
            #Special test with :log_overview.
            #Don't test stdout, but content of the overview-file
            when /:log_overview_file/
              assert_equal( 1, Dir['*'].size - dircontent.size , 'No log-overview created' ) #One file created
          end
          self.folder_for_failure = "../_failure#{Date.today}"
          assert_equal_filecontent( "../_expected/#{dir}_#{testcase}.txt", result,
                                            "Testcase #{dir}/#{testcase} changed content"
          )
        }#loop on test-tasks
      }#File rakefile
      assert_not_nil(testcase, "No testcase found in <#{dir}>")

      #Check overview file
      #~ 
      #~ `call rake log_overview`
      
      #~ `call rake clean`
      `call rake clobber` #PDFs not really needed after the test.
    }
  end
end