#
#Checks the test cases (May take some time, makes a lot TeX-runs).
#
gem 'more_unit_test', '>0.0.2'
gem 'test-unit'
require 'test/unit'
require 'more_unit_test/assert_equal_filecontent'

if $0 == __FILE__
  $:.unshift('../lib')
else
  #Change the directory. Relevant, if called from rakefile_rake4latex.rb
  Dir.chdir(File.dirname(__FILE__))
end
require 'rake4latex'
include Rake4LaTeX
require_relative('rake4latex_testhelper')

class Test_testdocument < Test::Unit::TestCase
  
  include Rake4latex_testhelper
  #
  #Loop on all test directories
  #
  Dir["*/"].each{|dir|  #get all directories
    #skip testcases form other test files
    next if dir =~ /^_/             #files for assert_equal_filecontent
    next if dir =~ /^splitindex/  #see unittest_splitindex.rb
    next if dir =~ /^rail/           #see unittest_rail.rb

    next if dir =~ /^dtx/  ###endless loop in rb 1.9.2

    #restrict for special tests (only for temporary use)
    #~ next unless dir =~ /bibtex/
    #~ next unless dir =~ /dtx/
    #~ next unless dir =~ /includes/
    #~ next unless dir =~ /complex/
    #~ next unless dir =~ /vario/
    #~ next unless dir =~ /two_tasks/
    #~ next unless dir =~ /^error/
    #~ next unless dir =~ /glossaries/
    #~ next unless dir =~ /ps2pdf/
    
    #Define testcase
    dir.chop! #delete trailing /
    class_eval <<code
      def test_#{dir}
        p 'testcase #{dir}'
        define_testcase( '#{dir}')
      end
code
  }
end

__END__
Started
...F.rake aborted!
uninitialized constant Open3

(See full trace by running task with --trace)
F..........FF

1) Failure:
test_error(Test_testdocument)
    [c:/program files/ruby19/lib/ruby/gems/1.9.1/gems/more_unit_test-0.1.2/lib/more_unit_test/assert_equal_filecontent.rb:105:in `assert_equal_filecontent'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:61:in `block (3 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `scan'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `block (2 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `open'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `block in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `chdir'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `define_testcase'
     (eval):2:in `test_error']:
Testcase error/test_overview changed content.
<"\nLog-overview for testdocument.tex\n  Document    : 1 page, 1 error (testdocument.log)\n--- \ntestdocument.log: \n  :latex_errors: \n  - Undefined control sequence. [log#282]\n  :output: \n  - Output written on testdocument.pdf (1 pages) [log#311]\n\n========\n   Detailed analyse of testdocument.log\n========\n###########\n##The following list may contain wrong line assignments\n###########\n--- \n:output: \n- Output written on testdocument.pdf (1 pages) [page0] [log#18] - []\n:latex_errors: \n- Undefined control sequence. (./testdocument.tex) [log#62] - []\n"> expected (../_expected/error_test_overview.txt) but was
<"\nLog-overview for testdocument.tex\n  Document    : 1 page, 1 error (testdocument.log)\n--- \ntestdocument.log: \n  :latex_errors: \n  - Undefined control sequence. [log#256]\n  :output: \n  - Output written on testdocument.pdf (1 pages) [log#279]\n\n========\n   Detailed analyse of testdocument.log\n========\n###########\n##The following list may contain wrong line assignments\n###########\n--- \n:latex_errors: \n- Undefined control sequence. (./testdocument.tex) [log#56] - []\n:output: \n- Output written on testdocument.pdf (1 pages) [page0] [log#17] - []\n">.
	-> Build <../_failure2011-08-23/error_test_overview.txt>.
<false> is not true.

2) Failure:
test_glossaries(Test_testdocument)
    [c:/program files/ruby19/lib/ruby/gems/1.9.1/gems/more_unit_test-0.1.2/lib/more_unit_test/assert_equal_filecontent.rb:105:in `assert_equal_filecontent'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:61:in `block (3 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `scan'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `block (2 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `open'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `block in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `chdir'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `define_testcase'
     (eval):2:in `test_glossaries']:
Testcase glossaries/test changed content.
<"\n INFO sample: StartLaTeXRunner for sample.tex\n INFO sample: Excute pdflatex -interaction=batchmode sample.tex\n INFO sample: Rerun necessary (aux-file changed)\n INFO sample: Call target sample.gls (true)\n INFO sample: Prepare glossaries [\"main\", \"acronym\"]\n INFO sample: Excute pdflatex -interaction=batchmode sample.tex\n INFO sample: Rerun necessary (aux-file changed)\n INFO sample: Call target sample.gls (true)\n INFO sample: Excute pdflatex -interaction=batchmode sample.tex\n INFO sample: Call target sample.gls (true)\n INFO sample: TeX-run stopped after 3 runs\n"> expected (../_expected/glossaries_test.txt) but was
<"\n INFO sample: StartLaTeXRunner for sample.tex\n INFO sample: Excute pdflatex -interaction=batchmode sample.tex\n INFO sample: Rerun necessary (aux-file changed)\n INFO sample: Call target sample.gls (true)\n INFO sample: Prepare glossaries [\"main\", \"acronym\"]\n">.
	-> Build <../_failure2011-08-23/glossaries_test.txt>.
<false> is not true.

3) Failure:
test_varioref(Test_testdocument)
    [c:/program files/ruby19/lib/ruby/gems/1.9.1/gems/more_unit_test-0.1.2/lib/more_unit_test/assert_equal_filecontent.rb:105:in `assert_equal_filecontent'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:61:in `block (3 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `scan'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `block (2 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `open'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `block in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `chdir'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `define_testcase'
     (eval):2:in `test_varioref']:
Testcase varioref/test_ignore_error changed content.
<"\n INFO LaTeXRunner: Clean: delete helpfiles [\"testdocument.aux\", \"testdocument.log\", \"testdocument.out\"]\n INFO LaTeXRunner: Clobber: delete helpfiles [\"testdocument.aux\", \"testdocument.log\", \"testdocument.out\", \"testdocument.pdf\"]\n INFO testdocument: StartLaTeXRunner for testdocument.tex\n INFO testdocument: Excute pdflatex -interaction=batchmode testdocument.tex\n INFO testdocument: Rerun necessary (aux-file changed)\n INFO testdocument: Excute pdflatex -interaction=batchmode testdocument.tex\nFATAL testdocument: There where pdflatex errors. See testdocument.log for details\n INFO testdocument: TeX-run stopped after 2 runs\nStatistic for testdocument:\n  Document    : 2 pages, 1 error (testdocument.log)\n"> expected (../_expected/varioref_test_ignore_error.txt) but was
<"\n INFO LaTeXRunner: Clean: delete helpfiles [\"testdocument.aux\", \"testdocument.log\", \"testdocument.out\"]\n INFO LaTeXRunner: Clobber: delete helpfiles [\"testdocument.aux\", \"testdocument.log\", \"testdocument.out\", \"testdocument.pdf\"]\n INFO testdocument: StartLaTeXRunner for testdocument.tex\n INFO testdocument: Excute pdflatex -interaction=batchmode testdocument.tex\n INFO testdocument: Rerun necessary (aux-file changed)\n INFO testdocument: Excute pdflatex -interaction=batchmode testdocument.tex\nFATAL testdocument: There where pdflatex errors. See testdocument.log for details\n INFO testdocument: TeX-run stopped after 2 runs\nStatistic for testdocument:\n  Document    : 2 pages, 1 error, 1 warning (testdocument.log)\n">.
	-> Build <../_failure2011-08-23/varioref_test_ignore_error.txt>.
<false> is not true.

4) Failure:
test_z_complex(Test_testdocument)
    [c:/program files/ruby19/lib/ruby/gems/1.9.1/gems/more_unit_test-0.1.2/lib/more_unit_test/assert_equal_filecontent.rb:105:in `assert_equal_filecontent'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:61:in `block (3 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `scan'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:46:in `block (2 levels) in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `open'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:42:in `block in define_testcase'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `chdir'
     C:/usr/script/rake4latex/test/rake4latex_testhelper.rb:31:in `define_testcase'
     (eval):2:in `test_z_complex']:
Testcase z_complex/test_overview changed content.
<"\nLog-overview for testdocument.tex\n  Document    : 9 pages, 4 warnings (testdocument.log)\n  Bibliography: Used testdocument.bib, 3 warnings (testdocument.blg)\n  Index       : 1 entry (testdocument-ani.ilg)\n  Index       : 1 entry (testdocument-veg.ilg)\n  Index       : 1 entry (testdocument-xxx.ilg)\n  Index       : 2 entries (testdocument-fru.ilg)\n  Index       : 3 entries (testdocument-idx.ilg)\n--- \ntestdocument.log: \n  :package_warnings: \n    minitoc(hints): \n    - W0030 [log#373]\n    - W0023 [log#378]\n    - W0039 [log#383]\n    - W0023 [log#388]\n    - W0024 [log#449]\n  :latex_warnings: \n  - No \\author given. [log#397]\n  - Citation `irgendwas' on page 5 undefined on input line 57. [log#428]\n  - There were undefined references. [log#463]\n  :output: \n  - Output written on testdocument.pdf (9 pages) [log#481]\ntestdocument.blg: \n  :source_information: \n  - Database file testdocument.bib used\n  :warnings: \n  - string name \"dtk\" is undefined\n  - Databaseentry irgendwas missing\n  - empty journal in dtk00.4:lickert:blindtext\ntestdocument-ani.ilg: \n  :source_information: \n  - \"Input file: testdocument-ani.idx.\"\n  - \"Entries accepted: 1\"\n  - \"Entries rejected: 0\"\ntestdocument-fru.ilg: \n  :source_information: \n  - \"Input file: testdocument-fru.idx.\"\n  - \"Entries accepted: 2\"\n  - \"Entries rejected: 0\"\ntestdocument-idx.ilg: \n  :source_information: \n  - \"Input file: testdocument-idx.idx.\"\n  - \"Entries accepted: 3\"\n  - \"Entries rejected: 0\"\ntestdocument-veg.ilg: \n  :source_information: \n  - \"Input file: testdocument-veg.idx.\"\n  - \"Entries accepted: 1\"\n  - \"Entries rejected: 0\"\ntestdocument-xxx.ilg: \n  :source_information: \n  - \"Input file: testdocument-xxx.idx.\"\n  - \"Entries accepted: 1\"\n  - \"Entries rejected: 0\"\n\n========\n   Detailed analyse of testdocument.log\n========\n###########\n##The following list may contain wrong line assignments\n###########\n--- \n:output: \n- Output written on testdocument.pdf (9 pages) [page0] [log#23] - []\n:package_warnings: \n  minitoc(hints): \n  - W0030 (./testdocument.tex) [log#96] - []\n  - W0023 (./testdocument.tex) [log#101] - []\n  - W0039 (./testdocument.tex) [log#106] - []\n  - W0023 (./testdocument.tex) [log#111] - []\n  - W0024 (./testdocument.tex) [log#163] - []\n:latex_warnings: \n- No \\author given. (./testdocument.tex) [log#120] - []\n- Citation `irgendwas' on page 5 undefined on input line 57. (./testdocument.tex) [log#150] - []\n- There were undefined references. (./testdocument.tex) [log#177] - []\n"> expected (../_expected/z_complex_test_overview.txt) but was
<"\nLog-overview for testdocument.tex\n  Document    : 9 pages, 4 warnings (testdocument.log)\n  Bibliography: Used testdocument.bib, 3 warnings (testdocument.blg)\n  Index       : 1 entry (testdocument-ani.ilg)\n  Index       : 1 entry (testdocument-veg.ilg)\n  Index       : 1 entry (testdocument-xxx.ilg)\n  Index       : 2 entries (testdocument-fru.ilg)\n  Index       : 3 entries (testdocument-idx.ilg)\n--- \ntestdocument-ani.ilg: \n  :source_information: \n  - \"Input file: testdocument-ani.idx.\"\n  - \"Entries accepted: 1\"\n  - \"Entries rejected: 0\"\ntestdocument-fru.ilg: \n  :source_information: \n  - \"Input file: testdocument-fru.idx.\"\n  - \"Entries accepted: 2\"\n  - \"Entries rejected: 0\"\ntestdocument-idx.ilg: \n  :source_information: \n  - \"Input file: testdocument-idx.idx.\"\n  - \"Entries accepted: 3\"\n  - \"Entries rejected: 0\"\ntestdocument-veg.ilg: \n  :source_information: \n  - \"Input file: testdocument-veg.idx.\"\n  - \"Entries accepted: 1\"\n  - \"Entries rejected: 0\"\ntestdocument-xxx.ilg: \n  :source_information: \n  - \"Input file: testdocument-xxx.idx.\"\n  - \"Entries accepted: 1\"\n  - \"Entries rejected: 0\"\ntestdocument.blg: \n  :source_information: \n  - Database file testdocument.bib used\n  :warnings: \n  - string name \"dtk\" is undefined\n  - Databaseentry irgendwas missing\n  - empty journal in dtk00.4:lickert:blindtext\ntestdocument.log: \n  :latex_warnings: \n  - No \\author given. [log#371]\n  - Citation `irgendwas' on page 5 undefined on input line 57. [log#418]\n  - There were undefined references. [log#447]\n  :output: \n  - Output written on testdocument.pdf (9 pages) [log#465]\n  :package_warnings: \n    minitoc(hints): \n    - W0030 [log#347]\n    - W0023 [log#352]\n    - W0039 [log#357]\n    - W0023 [log#362]\n    - W0024 [log#441]\n\n========\n   Detailed analyse of testdocument.log\n========\n###########\n##The following list may contain wrong line assignments\n###########\n--- \n:latex_warnings: \n- No \\author given. (./testdocument.tex) [log#114] - []\n- Citation `irgendwas' on page 5 undefined on input line 57. (./testdocument.tex) [log#145] - []\n- There were undefined references. (./testdocument.tex) [log#166] - []\n:output: \n- Output written on testdocument.pdf (9 pages) [page0] [log#22] - []\n:package_warnings: \n  minitoc(hints): \n  - W0030 (./testdocument.tex) [log#90] - []\n  - W0023 (./testdocument.tex) [log#95] - []\n  - W0039 (./testdocument.tex) [log#100] - []\n  - W0023 (./testdocument.tex) [log#105] - []\n  - W0024 (./testdocument.tex) [log#160] - []\n">.
	-> Build <../_failure2011-08-23/z_complex_test_overview.txt>.
<false> is not true.

Finished in 1019.21875 seconds.

